define {
BS_PUSHLIKE  = 0x00001000
BM_CLICK     = 0x00F5
BM_GETCHECK  = 0x00F0
BM_SETCHECK  = 0x00F1

BN_CLICKED   = 0

//BS_DEFPUSHBUTTON   = 0x00000001
BS_CHECKBOX        = 0x00000002
BS_AUTOCHECKBOX    = 0x00000003
BS_RADIOBUTTON     = 0x00000004
//BS_3STATE          = 0x00000005
//BS_AUTO3STATE      = 0x00000006
//BS_GROUPBOX        = 0x00000007
//BS_USERBUTTON      = 0x00000008
BS_AUTORADIOBUTTON = 0x00000009
}

define {
   bsClassic    = 0
   bsAsRadioBtn = 3
   bsAsCheckBox = 4
}


type vbtn <inherit = vctrl>
{
   str     p_caption
   onevent onclick  
   uint    p_checked 
   uint    p_btnstyle
}

property uint vbtn.checked()
{          
   if this.p_btnstyle == $bsAsCheckBox || this.p_btnstyle == $bsAsRadioBtn
   { 
      return this.winmsg( $BM_GETCHECK ) == 0x01
   }
   return this.p_checked
}

property vbtn.checked( uint val)
{
   if this.checked != val
   {
      
      if this.p_btnstyle == $bsAsCheckBox ||
         ( this.p_btnstyle == $bsAsRadioBtn && val )
      {
         uint tabstop = GetFocus()      
         this.winmsg( $BM_CLICK )
         SetFocus( tabstop )     
      }
      else : this.p_checked = val            
   }
}

property uint vbtn.btnstyle()
{
   return this.p_btnstyle
}

property vbtn.btnstyle( uint val)
{
   if this.p_btnstyle != val
   {      
      uint checked = this.checked
      uint remstyle = $BS_AUTORADIOBUTTON | $BS_AUTOCHECKBOX | $BS_PUSHLIKE
      uint addstyle 
      //this.checked = 0
      this.winmsg( $BM_SETCHECK, 0 )
      this.p_checked = 0
      if val == $bsAsRadioBtn
      {
         addstyle = $BS_AUTORADIOBUTTON | $BS_PUSHLIKE
      }
      elif val == $bsAsCheckBox
      {
         addstyle = $BS_AUTOCHECKBOX | $BS_PUSHLIKE  
      }      
      this.changestyle( addstyle, remstyle ) 
      this.p_btnstyle = val      
      this.checked = checked
   }
}

method uint vbtn.defproc( eventn ev )
{
   switch ev.code
   {      
      case $e_winntf
      {
         if ev->eventwnd.message == $WM_COMMAND &&
            ev->eventwnd.wpar >> 16 == $BN_CLICKED
         {              
            this.onclick.run()          
         }         
      }      
   }  
   return this->vctrl.defproc( ev )   
}


method vbtn vbtn.init( )
{   
   this.p_typename = "vbtn"   
   this.p_typeid = vbtn
   this.setdefproc()
   this.canfocus = 1
   this.p_tabstop = 1      
   this.loc.width = 100
   this.loc.height = 25
   return this 
}  

method vbtn vbtn.win()
{   
   this.hwnd = createwin( 0, "BUTTON", "", 
      $WS_CHILD | $WS_VISIBLE | $WS_CLIPSIBLINGS, 
      0, 0, this.loc.width, this.loc.height, 
      this.p_owner->vctrl.hwnd, 0, 0, &this )        
   SendMessage( this.hwnd, $WM_SETFONT, GetStockObject( $DEFAULT_GUI_FONT ),0 )                                                 
   return this
}


property str vbtn.caption <result>
{
   result = this.p_caption
}

property vbtn.caption( str val )
{
   this.p_caption = val
   SetWindowText( this.hwnd, val.ptr() ) 
}

//------------------------------------------------------------------------------

method vbtn.getprops( uint typeid, compMan cm )
{
   this->vctrl.getprops( typeid, cm)
   cm.addprops( typeid, %{ 
"taborder"     , uint   , 0,
"caption"      , str    , 0,
"btnstyle"     , uint   , 0,
"checked"      , uint   , 0 
   }) 
                   
   cm.addpropvalues( typeid, "btnstyle",%{ 
"bsClassic"       , $bsClassic         ,
"bsAsRadioBtn"    , $bsAsRadioBtn      ,     
"bsAsCheckBox"    , $bsAsCheckBox
   })
}

method vbtn.getevents( uint typeid, compMan cm )
{
   this->vctrl.getevents( typeid, cm)
   cm.addevents( typeid, %{
"onclick"      , "eventn"
   })
}