define {
   brdNone       =0   
   brdLowered    =2
   brdDblRaised  =3
   brdDblLowered =4
}
type vpanel <inherit = vctrl>
{
   str p_caption  
   uint p_border 
}

property str vpanel.caption <result>
{
   result = this.p_caption
}

property vpanel.caption( str val )
{
   if this.p_caption != val
   {
      this.p_caption = val
      SetWindowText( this.hwnd, val.ptr() )
   } 
}

property uint vpanel.border()
{
   return this.p_border
}

property vpanel.border( uint val )
{  
   uint style
   
   if this.p_border != val
   {
      this.p_border = val
      style = GetWindowLong( this.hwnd, $GWL_EXSTYLE )
      style &= ~( $WS_EX_STATICEDGE | $WS_EX_WINDOWEDGE | $WS_EX_CLIENTEDGE | $WS_EX_DLGMODALFRAME)
      switch val
      {         
         case $brdLowered    :  style |= $WS_EX_STATICEDGE             	
         case $brdDblRaised :  style |= /*$WS_EX_WINDOWEDGE |*/ $WS_EX_DLGMODALFRAME   
         case $brdDblLowered :  style |= $WS_EX_CLIENTEDGE         
      }
      SetWindowLong( this.hwnd, $GWL_EXSTYLE, style )      
      SetWindowPos( this.hwnd, 0, 0, 0, 0, 0, $SWP_FRAMECHANGED | $SWP_NOACTIVATE | $SWP_NOZORDER | $SWP_NOMOVE | $SWP_NOSIZE )      
   }     
}

method vpanel vpanel.init( )
{     
   this.p_typename = "vpanel"   
   this.p_typeid = vpanel   
   this.cancontain = 1   
   this.setdefproc()
   this.p_border = $brdLowered   
   this.loc.width = 100
   this.loc.height = 100
   return this 
}  

method vpanel vpanel.win()
{   
   this.hwnd = createwin( 0, "STATIC", "", 
$WS_CHILD | $WS_VISIBLE | $WS_CLIPCHILDREN | $WS_CLIPSIBLINGS | $WS_OVERLAPPED, 
      0, 0, this.loc.width, this.loc.height, 
      this.p_owner->vctrl.hwnd, 0, 0, &this )
   SendMessage( this.hwnd, $WM_SETFONT, GetStockObject( $DEFAULT_GUI_FONT ), 0 )
   if this.p_caption 
   {
      str p_caption = this.p_caption 
      this.p_caption = ""
      this.caption = p_caption
   }
   if this.p_border 
   {
      uint p_border = this.p_border 
      this.p_border = 0
      this.border = p_border
   }                       
                                                                           
   return this
}

//------------------------------------------------------------------------------

method vpanel.getprops( uint typeid, compMan cm )
{
   this->vctrl.getprops( typeid, cm)
   
   cm.addprops( typeid,%{ 
"taborder"     , uint   , 0,
"caption"      , str    , 0,
"border"       , uint   , 0
   })
      
   cm.addpropvalues( typeid, "border",%{ 
"brdNone"         ,  $brdNone          ,
"brdLowered"      ,  $brdLowered       ,       
"brdDblRaised"    ,  $brdDblRaised     ,
"brdDblLowered"   ,  $brdDblLowered
   })      

}

